// Java class syncdb.Conn is a proxy for talking to a Go program.
//   gobind -lang=java syncdb
//
// File is generated by gobind. Do not edit.
package syncdb;

import go.Seq;

/**
 * Conn represents a connection to a database. Two Connection objects
to the same database are READ_COMMITTED isolated.
 */
public final class Conn implements Seq.Proxy {
	static { Syncdb.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	Conn(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	public Conn() { this.refnum = __New(); Seq.trackGoRef(refnum, this); }
	
	private static native int __New();
	
	/**
	 * AbortTransaction aborts -- rolls back -- any active transaction. Calling code
	should know exactly what it is doing if it decides to call this function. It
	can be used to clean up any dangling state that may result from certain
	error scenarios.
	 */
	public native void abortTransaction() throws Exception;
	/**
	 * Backup writes a snapshot of the database over the given database
	connection, erasing all the contents of the destination database.
	The consistency of the snapshot is READ_COMMITTED relative to any
	other connections currently open to this database. The caller must
	ensure that all connections to the destination database are not
	accessed during this operation.
	 */
	public native void backup(Conn dst) throws Exception;
	/**
	 * Close closes the connection.
	 */
	public native void close() throws Exception;
	// skipped method Conn.Dump with unsupported parameter or return types
	
	/**
	 * EnableFKConstraints allows control of foreign key constraint checks.
	 */
	public native void enableFKConstraints(boolean e) throws Exception;
	// skipped method Conn.Execute with unsupported parameter or return types
	
	/**
	 * FKConstraints returns whether FK constraints are set or not.
	 */
	public native boolean fkConstraints() throws Exception;
	/**
	 * Load loads the connected database from the database connected to src.
	It overwrites the data contained in this database. It is the caller&#39;s
	responsibility to ensure that no other connections to this database
	are accessed while this operation is in progress.
	 */
	public native void load(Conn src) throws Exception;
	// skipped method Conn.Query with unsupported parameter or return types
	
	/**
	 * TransactionActive returns whether a transaction is currently active
	i.e. if the database is NOT in autocommit mode.
	 */
	public native boolean transactionActive();
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Conn)) {
		    return false;
		}
		Conn that = (Conn)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Conn").append("{");
		return b.append("}").toString();
	}
}

