// Java class syncdb.Result is a proxy for talking to a Go program.
//   gobind -lang=java syncdb
//
// File is generated by gobind. Do not edit.
package syncdb;

import go.Seq;

/**
 * Result represents the outcome of an operation that changes rows.
 */
public final class Result implements Seq.Proxy {
	static { Syncdb.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	Result(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	public Result() { this.refnum = __New(); Seq.trackGoRef(refnum, this); }
	
	private static native int __New();
	
	public final native long getLastInsertID();
	public final native void setLastInsertID(long v);
	
	public final native long getRowsAffected();
	public final native void setRowsAffected(long v);
	
	public final native String getError();
	public final native void setError(String v);
	
	public final native double getTime();
	public final native void setTime(double v);
	
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof Result)) {
		    return false;
		}
		Result that = (Result)o;
		long thisLastInsertID = getLastInsertID();
		long thatLastInsertID = that.getLastInsertID();
		if (thisLastInsertID != thatLastInsertID) {
		    return false;
		}
		long thisRowsAffected = getRowsAffected();
		long thatRowsAffected = that.getRowsAffected();
		if (thisRowsAffected != thatRowsAffected) {
		    return false;
		}
		String thisError = getError();
		String thatError = that.getError();
		if (thisError == null) {
			if (thatError != null) {
			    return false;
			}
		} else if (!thisError.equals(thatError)) {
		    return false;
		}
		double thisTime = getTime();
		double thatTime = that.getTime();
		if (thisTime != thatTime) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getLastInsertID(), getRowsAffected(), getError(), getTime()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("Result").append("{");
		b.append("LastInsertID:").append(getLastInsertID()).append(",");
		b.append("RowsAffected:").append(getRowsAffected()).append(",");
		b.append("Error:").append(getError()).append(",");
		b.append("Time:").append(getTime()).append(",");
		return b.append("}").toString();
	}
}

